///////////////////////////////////////////////////////////////
// `p}N`
///////////////////////////////////////////////////////////////

#pragma once


///////////////////////////////////////////////////////////////

#pragma region NX

namespace Box2DLib
{
	// bpNX
	public ref class Box2DObject abstract
	{
	public:

		// RXgN^
		Box2DObject() :
			mBaseObjectPtr( 0 ),
			mCreate( false )
		{

		}

		// fXgN^
		virtual ~Box2DObject()
		{
			BaseRelease();
		}

		// t@CiCU
		!Box2DObject()
		{
			BaseRelease();
		}

		// bIuWFNg
		property void* BaseObjectPtr	// bIuWFNgւ̃|C^(}l[Wp)
		{
			void* get()			{ return mBaseObjectPtr; }
			void set( void* v )	{ mBaseObjectPtr = v; }
		}
		property IntPtr BaseObject		// bIuWFNgւ̃|C^(}l[Wp)
		{
			IntPtr get()		{ return static_cast<IntPtr>(mBaseObjectPtr); }
		}
		
	protected:

		// IuWFNg쐬̏
		// 
		// @Flag			VɃx[XIuWFNg𐶐ꍇTrue(bpNXjɃx[Xj)
		virtual void OnCreateBase( bool Flag )
		{
			mCreate = Flag;
		}

		// bIuWFNg̊J
		virtual void BaseRelease()
		{
			if( mCreate )
			{	// IuWFNg̍폜
				BaseDelete();
				mCreate = false;
			}
			mBaseObjectPtr = 0; // NULL
		}

		// bIuWFNg̍폜
		virtual void BaseDelete() abstract;

	protected:
		void*		mBaseObjectPtr;		// bIuWFNg(lCeBuIuWFNg)
		bool		mCreate;			// bIuWFNgNXō쐬ꍇTrue
	};
}

#pragma endregion

///////////////////////////////////////////////////////////////

// }l[W
#define MNAME( name )			b##name

// A}l[W
#define UNAME( name )			::##name

///////////////////////////////////////////////////////////////

#pragma region `p}N

// `p}NS
// @V:l^Fint32float32̊{^(lCeBuƃ}l[Wŋ)
// @B:^Fb2Vec2b2Mat22̃lCeBuIuWFNg^
// @P:^|C^F^̃|C^(b2Vec2*Ab2Mat22*)
// @I:IntPtr^FlCeBuvoid*^(}l[W͔Cӂ{IIntPtr)
//   N:ȂFȂ̏ꍇp

// ֐`̈Xg
#define MAKE_DEFINE_PARAM( fmt, types )				MAKE_DEFINE_PARAM_##fmt types
#define MAKE_DEFINE_PARAM_N()																				// Ȃ
#define MAKE_DEFINE_PARAM_V( t1 )					FD_V(t1, p1)                                          	// l^
#define MAKE_DEFINE_PARAM_VV( t1, t2 )				FD_V(t1, p1), FD_V(t2, p2)                            	// l^Al^
#define MAKE_DEFINE_PARAM_VVV( t1, t2, t3 )			FD_V(t1, p1), FD_V(t2, p2), FD_V(t3, p3)              	// l^Al^Al^
#define MAKE_DEFINE_PARAM_VVVV( t1, t2, t3, t4 )	FD_V(t1, p1), FD_V(t2, p2), FD_V(t3, p3), FD_V(t4, p4)	// l^Al^Al^Al^
#define MAKE_DEFINE_PARAM_VVBV( t1, t2, t3, t4 )	FD_V(t1, p1), FD_V(t2, p2), FD_B(t3, p3), FD_V(t4, p4)	// l^Al^A^Al^
#define MAKE_DEFINE_PARAM_B( t1 )					FD_B(t1, p1)                                          	// ^
#define MAKE_DEFINE_PARAM_BB( t1, t2 )				FD_B(t1, p1), FD_B(t2, p2)                            	// ^A^
#define MAKE_DEFINE_PARAM_VB( t1, t2 )				FD_V(t1, p1), FD_B(t2, p2)                            	// l^A^
#define MAKE_DEFINE_PARAM_BV( t1, t2 )				FD_B(t1, p1), FD_V(t2, p2)                            	// ^Al^
#define MAKE_DEFINE_PARAM_BBB( t1, t2, t3 )			FD_B(t1, p1), FD_B(t2, p2), FD_B(t3, p3)              	// ^A^A^
#define MAKE_DEFINE_PARAM_BBV( t1, t2, t3 )			FD_B(t1, p1), FD_B(t2, p2), FD_V(t3, p3)              	// ^A^Al^
#define MAKE_DEFINE_PARAM_BVBV( t1, t2, t3, t4 )	FD_B(t1, p1), FD_V(t2, p2), FD_B(t3, p3), FD_V(t4, p4)	// ^Al^A^Al^
#define MAKE_DEFINE_PARAM_P( t1 )					FD_P(t1, p1)                                          	// ^|C^
#define MAKE_DEFINE_PARAM_PV( t1, t2 )				FD_P(t1, p1), FD_V(t2, p2)                            	// ^|C^Al^
#define MAKE_DEFINE_PARAM_PB( t1, t2 )				FD_P(t1, p1), FD_B(t2, p2)                            	// ^|C^A^
#define MAKE_DEFINE_PARAM_PBB( t1, t2, t3 )			FD_P(t1, p1), FD_B(t2, p2), FD_B(t3, p3)              	// ^|C^A^A^
#define MAKE_DEFINE_PARAM_PP( t1, t2 )				FD_P(t1, p1), FD_P(t2, p2)                            	// ^|C^A^|C^
#define MAKE_DEFINE_PARAM_PPB( t1, t2, t3 )			FD_P(t1, p1), FD_P(t2, p2), FD_B(t3, p3)              	// ^|C^A^|C^A^
#define MAKE_DEFINE_PARAM_PPBB( t1, t2, t3, t4 )	FD_P(t1, p1), FD_P(t2, p2), FD_B(t3, p3), FD_B(t4, p4)	// ^|C^A^|C^A^A^
#define MAKE_DEFINE_PARAM_PPBBBBV( t1, t2, t3, t4, t5, t6, t7 )	\
		  FD_P(t1, p1), FD_P(t2, p2), FD_B(t3, p3), FD_B(t4, p4), FD_B(t5, p5), FD_B(t6, p6), FD_V(t7, p7)	// ^|C^A^|C^A^A^A^A^Al^
#define MAKE_DEFINE_PARAM_I( t1 )					FD_I(t1, p1)											// IntPtr^
#define FD_V( type, name )		type name				// l^
#define FD_B( type, name )		MNAME(type)^ name		// ^
#define FD_P( type, name )		MNAME(type)^ name		// ^|C^
#define FD_I( type, name )		type name				// IntPtr^

// ֐ďöXg
#define MAKE_CALL_PARAM( fmt, types )				MAKE_CALL_PARAM_##fmt types
#define MAKE_CALL_PARAM_N()							                                                       	// Ȃ
#define MAKE_CALL_PARAM_V( t1 )						FC_V(t1, p1)											// l^
#define MAKE_CALL_PARAM_VV( t1, t2 )				FC_V(t1, p1), FC_V(t2, p2)                            	// l^Al^
#define MAKE_CALL_PARAM_VVV( t1, t2, t3 )			FC_V(t1, p1), FC_V(t2, p2), FC_V(t3, p3)              	// l^Al^Al^
#define MAKE_CALL_PARAM_VVVV( t1, t2, t3, t4 )		FC_V(t1, p1), FC_V(t2, p2), FC_V(t3, p3), FC_V(t4, p4)	// l^Al^Al^Al^
#define MAKE_CALL_PARAM_VVBV( t1, t2, t3, t4 )		FC_V(t1, p1), FC_V(t2, p2), FC_B(t3, p3), FC_V(t4, p4)	// l^Al^A^Al^
#define MAKE_CALL_PARAM_B( t1 )						FC_B(t1, p1)                                          	// ^
#define MAKE_CALL_PARAM_BB( t1, t2 )				FC_B(t1, p1), FC_B(t2, p2)                            	// ^A^
#define MAKE_CALL_PARAM_VB( t1, t2 )				FC_V(t1, p1), FC_B(t2, p2)                            	// l^A^
#define MAKE_CALL_PARAM_BV( t1, t2 )				FC_B(t1, p1), FC_V(t2, p2)                            	// ^Al^
#define MAKE_CALL_PARAM_BBB( t1, t2, t3 )			FC_B(t1, p1), FC_B(t2, p2), FC_B(t3, p3)              	// ^A^A^
#define MAKE_CALL_PARAM_BBV( t1, t2, t3 )			FC_B(t1, p1), FC_B(t2, p2), FC_V(t3, p3)              	// ^A^Al^
#define MAKE_CALL_PARAM_BVBV( t1, t2, t3, t4 )		FC_B(t1, p1), FC_V(t2, p2), FC_B(t3, p3), FC_V(t4, p4)	// ^Al^A^Al^
#define MAKE_CALL_PARAM_P( t1 )						FC_P(t1, p1)                                          	// ^|C^
#define MAKE_CALL_PARAM_PV( t1, t2 )				FC_P(t1, p1), FC_V(t2, p2)                            	// ^|C^Al^
#define MAKE_CALL_PARAM_PB( t1, t2 )				FC_P(t1, p1), FC_B(t2, p2)                            	// ^|C^A^
#define MAKE_CALL_PARAM_PBB( t1, t2, t3 )			FC_P(t1, p1), FC_B(t2, p2), FC_B(t3, p3)              	// ^|C^A^A^
#define MAKE_CALL_PARAM_PP( t1, t2 )				FC_P(t1, p1), FC_P(t2, p2)                            	// ^|C^A^|C^
#define MAKE_CALL_PARAM_PPB( t1, t2, t3 )			FC_P(t1, p1), FC_P(t2, p2), FC_B(t3, p3)              	// ^|C^A^|C^A^
#define MAKE_CALL_PARAM_PPBB( t1, t2, t3, t4 )		FC_P(t1, p1), FC_P(t2, p2), FC_B(t3, p3), FC_B(t4, p4)	// ^|C^A^|C^A^A^
#define MAKE_CALL_PARAM_PPBBBBV( t1, t2, t3, t4, t5, t6, t7 )	\
		  FC_P(t1, p1), FC_P(t2, p2), FC_B(t3, p3), FC_B(t4, p4), FC_B(t5, p5), FC_B(t6, p6), FC_V(t7, p7)	// ^|C^A^|C^A^A^A^A^Al^
#define MAKE_CALL_PARAM_I( t1 )						FC_I(t1, p1)                                          	// IntPtr^
#define FC_V( type, name )		name					// l^
#define FC_B( type, name )		(*(name->BasePtr))		// ^
#define FC_P( type, name )		(name->BasePtr)			// ^|C^
#define FC_I( type, name )		(static_cast<void*>(name))			// IntPtr^

// ֐`̖߂^쐬
#define MAKE_RETURNTYPE_N( t0 )				t0				// ߂l@Ȃ
#define MAKE_RETURNTYPE_V( t0 )				t0				// ߂l@l^
#define MAKE_RETURNTYPE_C( t0 )				t0				// ߂l@l^iLXgj
#define MAKE_RETURNTYPE_B( b0 )				MNAME(b0)^		// ߂l@^
#define MAKE_RETURNTYPE_P( b0 )				MNAME(b0)^		// ߂l@^|C^
#define MAKE_RETURNTYPE_E( t0 )				MNAME(t0)		// ߂l@l^(񋓌^)

// ֐̃R[h쐬
#define MAKE_RETURNVALUE_N( t0, value )		value									// lԂȂ
#define MAKE_RETURNVALUE_V( t0, value )		return value							// l^Ԃ
#define MAKE_RETURNVALUE_C( t0, value )		return static_cast<t0>( value )			// l^LXgĕԂ
#define MAKE_RETURNVALUE_B( b0, value )		return gcnew MNAME(b0)( value )			// ^쐬郉bpNX쐬ĕԂ
#define MAKE_RETURNVALUE_P( b0, value )		{ UNAME(b0)* rc = value; return (rc != NULL) ? (gcnew MNAME(b0)( rc )):(nullptr); }	// ^|C^bv郉bpNX쐬ĕԂ
#define MAKE_RETURNVALUE_E( t0, value )		return static_cast<MNAME(t0)>( value )	// l^(񋓌^)LXgĕԂ

#pragma endregion

///////////////////////////////////////////////////////////////

// 萔`p}N
#define DEFINE_CONST( vartype, basename )	\
	static const vartype MNAME(basename) = UNAME(basename);

// enum萔`
#define DEFINE_ENUM( basename )	\
	public enum class MNAME(basename)

// enum萔ڒ`
#define DEFINE_ENUMITEM( itemname )	\
	itemname = UNAME(itemname)

// 萔yєėp֐p\̒`
#define DEFINE_STATIC( name ) \
	public ref struct name sealed

///////////////////////////////////////////////////////////////

// \̃bpNX`
#define DEFINE_STRUCT( basename ) \
	public ref struct MNAME(basename) : public Box2DObject

// \̃bpNX`(p)
#define DEFINE_STRUCT_INHERIT( basename, parentbasename ) \
	public ref struct MNAME(basename) : public MNAME(parentbasename)

///////////////////////////////////////////////////////////////

// bIuWFNgւ̃ANZX`
#define DEFINE_BASEACCESS( basename ) \
	property UNAME(basename)* BasePtr \
	{ \
		UNAME(basename)* get()	{ return reinterpret_cast<UNAME(basename) *>(mBaseObjectPtr); } \
	}

// IuWFNgoւ̃ANZX
#define BASEMEMBER(	membername )		(BasePtr->membername)	

// IuWFNg̎擾
#define BASEOBJECT(	objectname )		(*(objectname->BasePtr))	


///////////////////////////////////////////////////////////////

// bIuWFNg̍폜
#define DEFINE_DELETEBASE( basename ) \
	virtual void BaseDelete() override \
	{ \
		delete reinterpret_cast<UNAME(basename) *>(mBaseObjectPtr); \
	}

// bIuWFNg̍폜(_~[)
#define DEFINE_DELETEBASE_DUMMY() \
	virtual void BaseDelete() override {}



///////////////////////////////////////////////////////////////

// ftHgRXgN^̒`
#define DEFINE_CONSTRUCTOR_DEFAULT( basename )	\
	MNAME(basename)() \
	{ \
		mBaseObjectPtr = reinterpret_cast<void *>(new UNAME(basename)()); \
		OnCreateBase( true ); \
	}

// ^bpRXgN^
#define DEFINE_CONSTRUCTOR_COPY( basename )	\
	MNAME(basename)( const UNAME(basename) Src ) \
	{ \
		mBaseObjectPtr = reinterpret_cast<void *>(new UNAME(basename)()); \
		*( reinterpret_cast<UNAME(basename) *>(mBaseObjectPtr) ) = Src; \
		OnCreateBase( true ); \
	}

// ^bpRXgN^
#define DEFINE_CONSTRUCTOR_WRAPPER( basename )	\
	MNAME(basename)( const UNAME(basename)* Src ) \
	{ \
		mBaseObjectPtr = reinterpret_cast<void *>(const_cast<UNAME(basename)*>(Src)); \
		OnCreateBase( false ); \
	}

// ^bpRXgN^(p)
#define DEFINE_CONSTRUCTOR_WRAPPERINHERIT( basename, parentbasename )	\
	MNAME(basename)( const UNAME(basename)* Src ) : MNAME(parentbasename)( Src ) \
	{ \
		mBaseObjectPtr = reinterpret_cast<void *>(const_cast<UNAME(basename)*>(Src)); \
		OnCreateBase( false ); \
	}

// RXgN^`(w)
#define DEFINE_CONSTRUCTOR( basename, paramfmt, param ) \
	MNAME(basename)( MAKE_DEFINE_PARAM( paramfmt, param) ) \
	{ \
		mBaseObjectPtr = reinterpret_cast<void *>(new UNAME(basename)( MAKE_CALL_PARAM( paramfmt, param ) )); \
		OnCreateBase( true ); \
	}

// ftHgRXgN^̒`(_~[)
#define DEFINE_CONSTRUCTOR_DEFAULTDUMMY( basename )	\
	MNAME(basename)() { }


// \̃vg^Cv錾
#define DEFINE_STRUCT_PROTOTYPE( basename ) \
	ref struct MNAME(basename);

// Rs[\bh`
#define DEFINE_COPYMETHOD( basename ) \
	void CopyFrom( MNAME(basename)^ src )		{ *( reinterpret_cast<UNAME(basename) *>(mBaseObjectPtr) ) = *( reinterpret_cast<UNAME(basename) *>(src->mBaseObjectPtr) ); } \
	void CopyFrom( UNAME(basename)* src )		{ *( reinterpret_cast<UNAME(basename) *>(mBaseObjectPtr) ) = *src; }

// ^LXg\bh`
#define DEFINE_CASTMETHOD( basename, srcbasename )	\
	static MNAME(basename)^ CastFrom( MNAME(srcbasename)^ src ) \
	{ \
		return gcnew MNAME(basename)( reinterpret_cast<UNAME(basename) *>(src->BasePtr) ); \
	}

///////////////////////////////////////////////////////////////

// \̃bpNX`Zbg
#define DEFINE_STRUCT_SET( basename ) \
		DEFINE_DELETEBASE( basename ) \
		DEFINE_BASEACCESS( basename ) \
		DEFINE_CONSTRUCTOR_DEFAULT( basename ) \
		DEFINE_CONSTRUCTOR_WRAPPER( basename ) \
		DEFINE_CONSTRUCTOR_COPY( basename ) \
		DEFINE_COPYMETHOD( basename )

///////////////////////////////////////////////////////////////

// \bh`
#define DEFINE_METHOD( rettype, ret, name, paramfmt, param ) \
	MAKE_RETURNTYPE_##rettype( ret ) name( MAKE_DEFINE_PARAM( paramfmt, param ) ) \
	{ \
		MAKE_RETURNVALUE_##rettype( ret, BasePtr->##name( MAKE_CALL_PARAM( paramfmt, param ) ) ); \
	}

// \bh`(R[hw)
#define DEFINE_METHOD_CODE( rettype, ret, name, paramfmt, param, code ) \
	MAKE_RETURNTYPE_##rettype( ret ) name( MAKE_DEFINE_PARAM( paramfmt, param ) ) code

// \bh`(`̂)
#define DEFINE_METHOD_DECLARE( rettype, ret, name, paramfmt, param ) \
	MAKE_RETURNTYPE_##rettype( ret ) name( MAKE_DEFINE_PARAM( paramfmt, param ) );

// \bh`(I[o[Ch)
#define DEFINE_METHOD_OVERRIDE( rettype, ret, name, paramfmt, param ) \
	virtual MAKE_RETURNTYPE_##rettype( ret ) name( MAKE_DEFINE_PARAM( paramfmt, param ) ) override \
	{ \
		MAKE_RETURNVALUE_##rettype( ret, BasePtr->##name( MAKE_CALL_PARAM( paramfmt, param ) ) ); \
	}

// \bh`(NX`Oł̒`)
#define DEFINE_CLASSMETHOD( basename, rettype, ret, name, paramfmt, param ) \
	MAKE_RETURNTYPE_##rettype( ret ) MNAME(basename)::name( MAKE_DEFINE_PARAM( paramfmt, param ) ) \
	{ \
		MAKE_RETURNVALUE_##rettype( ret, BasePtr->##name( MAKE_CALL_PARAM( paramfmt, param ) ) ); \
	}
	

// O[o֐`
#define DEFINE_FUNCTIONSTATIC( rettype, ret, name, paramfmt, param ) \
MAKE_RETURNTYPE_##rettype( ret ) name( MAKE_DEFINE_PARAM( paramfmt, param ) ) \
	{ \
		MAKE_RETURNVALUE_##rettype( ret, UNAME(name)( MAKE_CALL_PARAM( paramfmt, param ) ) ); \
	}

// 񉻊֐`
#define DEFINE_TOSTRING( msg ) \
	virtual String^ ToString() override \
	{ \
		return String::Format msg; \
	}

///////////////////////////////////////////////////////////////

// \̃oANZX(l^)
#define DEFINE_PROPERTY_V( vartype, varname )	\
	property vartype varname \
	{ \
		vartype get()			{ return BasePtr->varname; } \
		void set( vartype v )	{ BasePtr->varname = v; } \
	}

// \̃oANZX(l^ALXg)
#define DEFINE_PROPERTY_C( vartype, varname, getcast, setcast )	\
	property vartype varname \
	{ \
		vartype get()			{ return getcast (BasePtr->varname); } \
		void set( vartype v )	{ BasePtr->varname = setcast (v); } \
	}

// \̃oANZX(l^AR[hw)
#define DEFINE_PROPERTY_V_CODE( vartype, varname, getcode, setcode )	\
	property vartype varname \
	{ \
		vartype get()			getcode \
		void set( vartype v )	setcode \
	}

// \̃oANZX(l^(񋓌^))
#define DEFINE_PROPERTY_E( vartype, varname )	\
	property MNAME(vartype) varname \
	{ \
		MNAME(vartype) get()			{ return static_cast<MNAME(vartype)>(BasePtr->varname); } \
		void set( MNAME(vartype) v )	{ BasePtr->varname = static_cast<UNAME(vartype)>(v); } \
	}



// \̃oANZX(^)
#define DEFINE_PROPERTY_B( vartype, varname ) \
	MNAME(vartype)^		_##varname; \
	MNAME(vartype)^ Get_##varname() \
	{ \
		if( ! _##varname ) { _##varname = gcnew MNAME(vartype)( &(BASEMEMBER(varname)) ); } \
		return _##varname; \
	} \
	property MNAME(vartype)^ varname \
	{ \
		MNAME(vartype)^ get()			{ return Get_##varname(); } \
		void set( MNAME(vartype)^ v )	{ Get_##varname()->CopyFrom( v ); } \
	}

// \̃oANZX(^AR[hw)
#define DEFINE_PROPERTY_B_CODE( vartype, varname, createcode ) \
	MNAME(vartype)^		_##varname; \
	MNAME(vartype)^ Get_##varname() \
	{ \
		if( ! _##varname ) { _##varname = gcnew MNAME(vartype)( createcode ); } \
		return _##varname; \
	} \
	property MNAME(vartype)^ varname \
	{ \
		MNAME(vartype)^ get()			{ return Get_##varname(); } \
		void set( MNAME(vartype)^ v )	{ Get_##varname()->CopyFrom( v ); } \
	}

// \̃oANZX(^z)
#define DEFINE_PROPERTY_BA( vartype, varname, maxcount ) \
	array<MNAME(vartype)^>^		_##varname; \
	MNAME(vartype)^ Get_##varname( int Index ) \
	{ \
		if( ! _##varname )				{ _##varname = gcnew array<MNAME(vartype)^>( maxcount ); } \
		if( ! _##varname[ Index ] )		{ _##varname[ Index ] = gcnew MNAME(vartype)( &(BASEMEMBER(varname)[ Index ]) ); } \
		return _##varname[ Index ]; \
	} \
	property MNAME(vartype)^ varname [int] \
	{ \
		MNAME(vartype)^ get( int Index )			{ return Get_##varname( Index ); } \
		void set( int Index, MNAME(vartype)^ v )	{ Get_##varname( Index )->CopyFrom( v ); } \
	}

// \̃oANZX(^zAR[hw)
#define DEFINE_PROPERTY_BA_CODE( vartype, varname, maxcount, createcode ) \
	array<MNAME(vartype)^>^		_##varname; \
	MNAME(vartype)^ Get_##varname( int Index ) \
	{ \
		if( ! _##varname )				{ _##varname = gcnew array<MNAME(vartype)^>( maxcount ); } \
		if( ! _##varname[ Index ] )		{ _##varname[ Index ] = gcnew MNAME(vartype)( createcode ); } \
		return _##varname[ Index ]; \
	} \
	property MNAME(vartype)^ varname [int] \
	{ \
		MNAME(vartype)^ get( int Index )			{ return Get_##varname( Index ); } \
		void set( int Index, MNAME(vartype)^ v )	{ Get_##varname( Index )->CopyFrom( v ); } \
	}


// \̃oANZX(^|C^)
#define DEFINE_PROPERTY_P( vartype, varname ) \
	MNAME(vartype)^		_##varname; \
	MNAME(vartype)^ Get_##varname() \
	{ \
		if( ! _##varname ) { _##varname = gcnew MNAME(vartype)( BASEMEMBER(varname) ); } \
		return _##varname; \
	} \
	property MNAME(vartype)^ varname \
	{ \
		MNAME(vartype)^ get()			{ return Get_##varname(); } \
		void set( MNAME(vartype)^ v )	{ BASEMEMBER(varname) = v->BasePtr; } \
	}
