/*
* Copyright (c) 2008 Masaki Oshikiri
*
* This software is provided 'as-is', without any express or implied
* warranty.  In no event will the authors be held liable for any damages
* arising from the use of this software.
* Permission is granted to anyone to use this software for any purpose,
* including commercial applications, and to alter it and redistribute it
* freely, subject to the following restrictions:
* 1. The origin of this software must not be misrepresented; you must not
* claim that you wrote the original software. If you use this software
* in a product, an acknowledgment in the product documentation would be
* appreciated but is not required.
* 2. Altered source versions must be plainly marked as such, and must not be
* misrepresented as being the original software.
* 3. This notice may not be removed or altered from any source distribution.
*/
/*
This product includes software developed by Erin Catto (http://www.gphysics.com).
*/


///////////////////////////////////////////////////////////////
// Box2D for .Net
///////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////
// Box2Dݒ

// Nw
#pragma comment( lib, "box2d.lib" )
// Nlibcmt.lib𖳎邱ƁB(/NODEFAULTLIB:"libcmt.lib")

#include "Box2D.h"

///////////////////////////////////////////////////////////////

using namespace System;
using namespace System::Collections;
using namespace System::Collections::Generic;

#include "Debug.h"
#include "Common.h"

///////////////////////////////////////////////////////////////

#include "mb2Settings.h"
#include "mb2Math.h"

#include "mb2Collision.h"

#include "mb2Shape.h"
#include "mb2PolygonShape.h"
#include "mb2CircleShape.h"

#include "mb2Body.h"

#include "mb2Joint.h"
#include "mb2DistanceJoint.h"
#include "mb2MouseJoint.h"
#include "mb2PrismaticJoint.h"
#include "mb2RevoluteJoint.h"
#include "mb2PulleyJoint.h"
#include "mb2GearJoint.h"

#include "mb2World.h"

///////////////////////////////////////////////////////////////

public ref class ClassA
{

};

namespace Box2DLib
{
	public value class DataA
	{
	public:
		int		Data1;
		int		Data2;

		DataA( int D1, int D2 )
		{
			Data1 = D1;
			Data2 = D2;
		}
	};

}
