
#pragma once

namespace Box2DLib
{

	DEFINE_STRUCT_INHERIT( b2GearJointDef, b2JointDef )
	{
		DEFINE_STRUCT_SET( b2GearJointDef );

		DEFINE_PROPERTY_P( b2Joint, joint1 );
		DEFINE_PROPERTY_P( b2Joint, joint2 );
		DEFINE_PROPERTY_V( float32, ratio );
	};

	DEFINE_STRUCT_INHERIT( b2GearJoint, b2Joint )
	{
		DEFINE_CONSTRUCTOR_WRAPPERINHERIT( b2GearJoint, b2Joint );
		DEFINE_BASEACCESS( b2GearJoint );
		DEFINE_COPYMETHOD( b2GearJoint );
		DEFINE_CASTMETHOD( b2GearJoint, b2Joint );

		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetAnchor1, N, () );
		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetAnchor2, N, () );

		DEFINE_METHOD_OVERRIDE( B, b2Vec2, GetReactionForce, N, () );
		DEFINE_METHOD_OVERRIDE( V, float32, GetReactionTorque, N, () );

		DEFINE_METHOD( V, float32, GetRatio, N, () );
	};

}
