
#pragma once

namespace Box2DLib
{
	DEFINE_STRUCT_INHERIT( b2CircleDef, b2ShapeDef )
	{
		DEFINE_STRUCT_SET( b2CircleDef );

		DEFINE_PROPERTY_B( b2Vec2, localPosition );
		DEFINE_PROPERTY_V( float32, radius );
	};

	DEFINE_STRUCT_INHERIT( b2CircleShape, b2Shape )
	{
		DEFINE_CONSTRUCTOR_WRAPPERINHERIT( b2CircleShape, b2Shape );
		DEFINE_BASEACCESS( b2CircleShape );
		DEFINE_COPYMETHOD( b2CircleShape );
		DEFINE_CASTMETHOD( b2CircleShape, b2Shape );

		DEFINE_METHOD_OVERRIDE( V, bool, TestPoint, BB, (b2XForm, b2Vec2) );
		// ToDo : virtual bool TestSegment(	const b2XForm& xf, float32* lambda, b2Vec2* normal, const b2Segment& segment, float32 maxLambda) const;
		DEFINE_METHOD_OVERRIDE( N, void, ComputeAABB, PB, (b2AABB, b2XForm) );
		DEFINE_METHOD_OVERRIDE( N, void, ComputeSweptAABB, PBB, (b2AABB, b2XForm, b2XForm) );
		DEFINE_METHOD_OVERRIDE( N, void, ComputeMass, P, (b2MassData) );

		DEFINE_METHOD( B, b2Vec2, GetLocalPosition, N, () );
		DEFINE_METHOD( V, float32, GetRadius, N, () );

		DEFINE_PROPERTY_B_CODE( b2Vec2, LocalPosition, (&BASEMEMBER(GetLocalPosition())) );
	};


}
